---
title: 'Window: message event'
slug: Web/API/Window/message_event
tags:
  - Event
---
<div>{{APIRef}}</div>

<p>The <code>message</code> event is fired on a {{domxref('Window')}} object when the window receives a message, for example from a call to <code><a href="/en-US/docs/Web/API/Window/postMessage">Window.postMessage()</a></code> from another browsing context.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("MessageEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td><code><a href="/en-US/docs/Web/API/WindowEventHandlers/onmessage">onmessage</a></code></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>Suppose a script sends a message to a different browsing context, such as another <code><a href="/en-US/docs/Web/HTML/Element/iframe">&lt;iframe&gt;</a></code>, using code like this:</p>

<pre class="brush: js">const targetFrame = window.top.frames[1];
const targetOrigin = 'https://example.org';
const windowMessageButton = document.querySelector('#window-message');

windowMessageButton.addEventListener('click', () =&gt; {
    targetFrame.postMessage('hello there', targetOrigin);
});</pre>

<p>The receiver can listen for the message using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> with code like this:</p>

<pre class="brush: js">window.addEventListener('message', (event) =&gt; {
    console.log(`Received message: ${event.data}`);
});</pre>

<p>Alternatively the listener could use the <code><a href="/en-US/docs/Web/API/WindowEventHandlers/onmessage">onmessage</a></code> event handler property:</p>

<pre class="brush: js">window.onmessage = (event) =&gt; {
    console.log(`Received message: ${event.data}`);
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'indices.html#event-message')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.message_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: <code><a href="/docs/Web/API/Window/messageerror_event">messageerror</a></code>.</li>
 <li><code><a href="/en-US/docs/Web/API/Window/postMessage">Window.postMessage()</a></code>.</li>
</ul>
